"""
Copyright (c) Perforce Software, Inc., 2012. All rights reserved

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1.  Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

2.  Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
    FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL PERFORCE
    SOFTWARE, INC. BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
    ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
    DAMAGE.

    User contributed content on the Perforce Public Depot is not supported by Perforce,
    although it may be supported by its author. This applies to all contributions 
    even those submitted by Perforce employees.

"""
#!python
# Saves updated configuration data

# imports
import sys 
import logging
from Cbd import Cbd

# globals to read from broker
p4port = None
reqUser = None
reqConfigDepotPath = None
reqData = None

# other globals
log = None
cbd = None

# parse arguments: normal broker args plus...
# 1. Configuration
# 2. XML data
def parseArgs():
    global p4port
    global reqUser
    global reqConfigDepotPath
    global reqData

    vals = cbd.parseBrokerArgs()
    
    argCount = vals['argCount']
    if argCount != '3':
        log.warn("Invalid number of arguments: %s" % argCount)
        print "action: REJECT\nmessage: \"Usage: p4 submit -Q <configuration> <XML data>\"";
        sys.exit(1)
    p4port = vals['brokerTargetPort']
    reqUser = vals['user']
    reqConfigDepotPath = vals['Arg1']
    reqData = vals['Arg2']

# main program
cbd = Cbd('broker')
log = cbd.getLogger()
parseArgs()
cbd.initP4(p4port)
cbd.updateCfg(reqConfigDepotPath, reqUser, reqData)

print "action: RESPOND\nmessage: \"Configuration %s updated\"" % (reqConfigDepotPath);
